class LSystemClass {
  String axiom;
  String[][] rules;
  float size;
  float angle;
  float scale;
  
  String computedWord;
  
  public LSystemClass(String ax, String[][] rule, float size, float angle, float scale) {
    this.axiom = ax;
    this.rules = rule;
    this.size = size;
    this.angle = angle;
    this.scale = scale;
    
    computedWord = this.axiom;
  }
  
  void iterate() {
    String tmp = "";
    this.size *= this.scale;
    for (char ch: this.computedWord.toCharArray()) {
      for (String[] rule: this.rules) {
        if (ch == rule[0].charAt(0)) {
          tmp += rule[(int)random(1, rule.length)];
          break;
        }
      }
    }
    
    this.computedWord = tmp;
  }
  
  void drawLSystem(Turtle t) {
    for (char ch: this.computedWord.toCharArray()) {
      if (ch == 'F') t.forward(this.size + random(-this.size/5, this.angle/5));
      else if (ch == '+') t.right(this.angle + random(-this.angle/2, this.angle/2));
      else if (ch == '-') t.left(this.angle + random(-this.angle/2, this.angle/2));
      else if (ch == '[') t.push();
      else if (ch == ']') t.pop();
      else if (ch == 'X') {
        // add "leaf" visuals here if desired
      }
    }
  }
  
}
